"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var transport_1 = require("ataraxia/transport");
/**
 * Abstract implementation of a peer suitable for use with a WebSocket
 * instance.
 */
var AbstractWebSocketPeer = /** @class */ (function (_super) {
    __extends(AbstractWebSocketPeer, _super);
    function AbstractWebSocketPeer(parent, authProviders) {
        return _super.call(this, parent, authProviders) || this;
    }
    AbstractWebSocketPeer.prototype.setSocket = function (socket) {
        var _this = this;
        this.socket = socket;
        socket.binaryType = 'arraybuffer';
        socket.addEventListener('message', function (event) {
            if (!(event.data instanceof ArrayBuffer)) {
                // We only work with ArrayBuffer
                return;
            }
            var decoded = transport_1.decodeBinaryPeerMessage(event.data);
            if (decoded) {
                _this.receiveData(decoded[0], decoded[1]);
            }
        });
        socket.addEventListener('error', function () {
            if (socket === _this.socket) {
                _this.handleDisconnect(transport_1.DisconnectReason.Error, new Error('Disconnecting due to error'));
            }
        });
        socket.addEventListener('close', function () {
            if (_this.socket) {
                // Unknown disconnect reason
                _this.handleDisconnect(transport_1.DisconnectReason.Error);
            }
        });
    };
    AbstractWebSocketPeer.prototype.requestDisconnect = function (reason, err) {
        if (!this.socket) {
            return;
        }
        var socket = this.socket;
        this.handleDisconnect(reason, err);
        socket.close();
    };
    AbstractWebSocketPeer.prototype.disconnect = function () {
        _super.prototype.disconnect.call(this);
        if (!this.socket) {
            return;
        }
        var socket = this.socket;
        this.handleDisconnect(transport_1.DisconnectReason.Manual);
        socket.close();
    };
    AbstractWebSocketPeer.prototype.handleDisconnect = function (reason, err) {
        this.socket = undefined;
        _super.prototype.handleDisconnect.call(this, reason, err);
    };
    AbstractWebSocketPeer.prototype.send = function (type, payload) {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                if (!this.socket) {
                    this.debug('No socket but tried to send', type, 'with data', payload);
                    return [2 /*return*/];
                }
                this.debug('Sending', transport_1.PeerMessageType[type], 'with data', payload);
                data = transport_1.encodeBinaryPeerMessage(type, payload);
                this.socket.send(data);
                return [2 /*return*/];
            });
        });
    };
    return AbstractWebSocketPeer;
}(transport_1.AbstractPeer));
exports.AbstractWebSocketPeer = AbstractWebSocketPeer;
//# sourceMappingURL=AbstractWebSocketPeer.js.map