"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AbstractWebSocketPeer_1 = require("./AbstractWebSocketPeer");
var WebSocketClientPeer = /** @class */ (function (_super) {
    __extends(WebSocketClientPeer, _super);
    function WebSocketClientPeer(parent, authProviders, factory, url) {
        var _this = _super.call(this, parent, authProviders) || this;
        _this.factory = factory;
        _this.url = url;
        return _this;
    }
    WebSocketClientPeer.prototype.handleDisconnect = function (reason, err) {
        var _this = this;
        // If we are already waiting for a connection ignore this call
        if (this.connectTimeout)
            return;
        _super.prototype.handleDisconnect.call(this, reason, err);
        // TODO: Smarter back-off algorithm
        var retryTime = 30000;
        this.debug('Reconnecting in', retryTime, 'ms');
        this.connectTimeout = setTimeout(function () { return _this.tryConnect(); }, retryTime);
    };
    WebSocketClientPeer.prototype.tryConnect = function () {
        var _this = this;
        // Make sure to clear the connection timeout when attempting to reconnect
        clearTimeout(this.connectTimeout);
        this.connectTimeout = null;
        // Create and setup the new WebSocket
        var ws = this.factory(this.url);
        ws.addEventListener('open', function () {
            _this.debug('Connected');
            _this.negotiateAsClient();
        });
        this.setSocket(ws);
    };
    WebSocketClientPeer.prototype.disconnect = function () {
        _super.prototype.disconnect.call(this);
        clearTimeout(this.connectTimeout);
    };
    return WebSocketClientPeer;
}(AbstractWebSocketPeer_1.AbstractWebSocketPeer));
exports.WebSocketClientPeer = WebSocketClientPeer;
//# sourceMappingURL=WebSocketClientPeer.js.map